#!/usr/bin/env python
# coding: utf-8

# 

# In[ ]:





# In[1]:


import numpy as np
import os
import matplotlib.pyplot as plt

### INPUTS ###
# TXT files from IF average
# 1 set of "lights" and 1 set of "darks"

### OUTPUTS ###
# TXTfile with frequency
# TXT file with averaged relative amplitude spectrum
# graph with averaged spectrum
# graph with sample spectrum
# "waterfall" spectrum

os.system('cls' if os.name == 'nt' else 'clear')
print('An application for plotting data from SDR#')
print('Rename all lights to light1.txt light2.txt.....')
print('Rename all darks to dark1.txt dark2.txt.....')

print('')

N_files = int(str(input('Number of Lights: ')))                  #number of files to be processed
N_darks1 = int(str(input('Number of Darks: ')))                  #number of files to be processed
T_int = float(str(input('Exposure time per light [sec]: ')))     #integration time in seconds

selint1 = int(str(input('Lowest FFT [recommended 1]: ')))        # lower index for slicing spectrum array
selint2 = int(str(input('Highest FFT [recommended 1024]: ')))    #higher index FFT
powermin = float(str(input('Minimum Power measured: ')))         # minimum power measured
powermax = float(str(input('Maximum Power measured: ')))         # maximum power measured
lowintgem = float(str(input('Lower bound of trendline [recommended 200]: ')))         # maximum power measured
highintgem = float(str(input('Higher bound of trendline [recommended 400]: ')))         # maximum power measured
spreadint = float(str(input('Number of bins below and above the limits to be sampled for calculating trendline [8]: ')))         # maximum power measured
waterfallmin = float(str(input('Lowest waterfall value [recommended 0.9950]: ')))       
waterfallmax = float(str(input('Highest waterfall value [recommended 1.1630]: ')))   

averaging = float(str(input('Average over a number of bins (ONLY uneven integers will work! (e.g. 1, 3, 5...) [1]: ')))# maximum power measured
filenames="light"   #common denominator "light" txt files
outputfnamedrift="driftscan"  # name of output txt files
column_separator="  "  #character that separates the frequency and intensity columns
T_int2=T_int

#input parameters
#N_files=55       #number of files to be processed
#N_darks1=33     # number of darks in set 1
N_darks2=0     # number of darks set 2
filenames="light" #common denominator "light" txt files
dark_filenames_1="dark"  # denominator darks set 1
dark_filenames_2="dark2" # darks set 2
column_separator="  "  #character that separates the frequency and intensity columns
#T_int=180           #integration time in seconds
#lowintgem=400      #lower bound of trendline definition
#highintgem=600     #higher bound of trendline
#spreadint=8        # number of bins below and above the limits to be sampled for calculating trendline
#selint1=400        # lower index for slicing spectrum array
#selint2=600        #higher index
select_spectrum=1    #select an individual spectrum for plotting#
#averaging=1            # average over a number of bins (ONLY uneven integers will work! (e.g. 1, 3, 5...))
outputfname="dataout"  # name of output txt files

#program:
N_darks=N_darks1+N_darks2
lowint1=lowintgem-spreadint-1
lowint2=lowintgem+spreadint
highint1=highintgem-spreadint-1
highint2=highintgem+spreadint
N_integers=1+2*spreadint
diff_int=highint1-lowint1

T_tot=N_files*T_int  #total observing time

average_int=averaging//2  #number of bins below and above a certain bin to be averaged

testfile=(str(filenames)+"1.txt")  #loading first file to determine the number of bins and the frequency axis
testspectrum=np.genfromtxt(fname=testfile, delimiter=column_separator, dtype=float, skip_header=1)
arrayshape=testspectrum.shape
N_bins=arrayshape[0]         #number of bins
testspect=testspectrum.T    #transposing the testspectrum so the frequency column can be sliced
frequency=testspect[0]
#print(testspect)
freq_select=frequency[selint1:selint2]

time=np.linspace(0, T_tot, N_files)

spectrumarray=np.zeros([N_files, N_bins])
darkarray=np.zeros([N_darks, N_bins])
indices=np.linspace(0, N_bins, N_bins)
linearray=np.zeros([N_files, N_bins])
sel_indices=indices[selint1:selint2]
masterdark=np.zeros([N_bins])

for s in range(N_darks1):
    
    #generate the filenames of the first set of darks
    L=s+1
    if L<10:
        dname=(str(dark_filenames_1)+"%s.txt" %L)
    elif L<100:
        dname=(str(dark_filenames_1)+"%s.txt" %L)
    else:
        dname=(str(dark_filenames_1)+"%s.txt" %L)
    
    #importing spectrum text files
    spectrum_d=np.genfromtxt(fname=dname, delimiter="  ", dtype=float, skip_header=1)
    
    Tspec_d=spectrum_d.T
    intseries_d=Tspec_d[1]
    darkarray[s]=intseries_d
    
for t in range(N_darks2):
    
    #generate the filenames of the first set of darks
    M=t+1
    if M<10:
        d2name=(str(dark_filenames_2)+"%s.txt" %M)
    elif M<100:
        d2name=(str(dark_filenames_2)+"%s.txt" %M)
    else:
        d2name=(str(dark_filenames_2)+"%s.txt" %M)
    
    #importing spectrum text files
    spectrum_d2=np.genfromtxt(fname=d2name, delimiter="  ", dtype=float, skip_header=1)
    
    Tspec_d2=spectrum_d2.T
    intseries_d2=Tspec_d2[1]
    darkarray[t+N_darks1]=intseries_d2
    
darkarray_T=darkarray.T

for u in range(N_bins):
    darkbins=darkarray_T[u]
    avgdbin=(np.sum(darkbins))/N_darks
    masterdark[u]=avgdbin
    

for i in range(N_files):
    
    #generate the filenames
    N=i+1
    if N<10:
        name=(str(filenames)+"%s.txt" %N)
    elif N<100:
        name=(str(filenames)+"%s.txt" %N)
    else:
        name=(str(filenames)+"%s.txt" %N)
    
    #importing spectrum text files
    spectrum=np.genfromtxt(fname=name, delimiter="  ", dtype=float, skip_header=1)
    
    Tspec=spectrum.T
    intseries=Tspec[1]
    Dsub_intseries=intseries/masterdark   #dark subtraction
    spectrumarray[i]=Dsub_intseries   #filling the spectrum array
    
    A1=Dsub_intseries[int(lowint1):int(lowint2)]    #calculating trendlines
    A2=Dsub_intseries[int(highint1):int(highint2)]
    gem_A1=np.sum(A1)/N_integers
    gem_A2=np.sum(A2)/N_integers
    trend=(gem_A2-gem_A1)/diff_int
    
    b1=gem_A1-trend*lowintgem
    b2=gem_A2-trend*highintgem
    
    bgem=(b1+b2)/2
    trendline=trend*indices+bgem
    linearray[i]=trendline
    
cal_spectrumarray=spectrumarray/linearray  #subtracting the trendlines (normalization to 1)

# averaging
av_spectrumarray=np.zeros([N_files, N_bins])

for p in range(N_files):
    for q in range(N_bins):
        lbin=q-average_int-1
        hbin=q+average_int
        partofspec=cal_spectrumarray[int(p), int(lbin):int(hbin)]
        averagedbins=np.sum(partofspec)/averaging
        av_spectrumarray[p, q]=averagedbins
        
          
#now we slice the array to get the interesting part

cal_spect=av_spectrumarray.T
averagedspectrum=np.zeros([N_bins])
for spex in range(N_bins):
    spexbins=cal_spect[spex]
    avespexbins=np.sum(spexbins)/N_files
    averagedspectrum[spex]=avespexbins

interesting_bit_t=cal_spect[selint1:selint2]   #selecting a sample spectrum
interesting_bit=interesting_bit_t.T
selected_spectrum=interesting_bit[select_spectrum]

avspectrumpart=averagedspectrum[selint1:selint2]   #time-averaged spectrum

np.savetxt(fname=outputfname, X=avspectrumpart)
np.savetxt(fname=outputfname+"freq", X=freq_select)

plt.figure(figsize=(10,10)) 
plt.plot(freq_select, avspectrumpart)
plt.xlabel("frequency (MHz)")
plt.title("averaged spectrum")
plt.savefig("Averaged_Spectrum.png")
plt.show()


plt.figure(figsize=(10,10)) 
plt.plot(freq_select, selected_spectrum)
#plt.ylim(0.9990, 1.002)
plt.xlabel("frequency (MHz)")
plt.title("sample spectrum")
plt.savefig("Sample_Spectrum")
plt.show()


plt.figure(figsize=(10,10)) 
plt.contourf(freq_select, time, interesting_bit, cmap=plt.cm.hot, levels=1000, vmin=waterfallmin, vmax=waterfallmax)
#plt.imgshow(freq_select, time, interesting_bit, cmap='RdYlGn', levels=1000, vmin=waterfallmin, vmax=waterfallmax)
plt.title("Waterfall")
plt.xlabel("frequency (MHz)")
plt.ylabel("time (seconds)")
plt.colorbar()
plt.savefig("Waterfall.png")
plt.show()







# In[ ]:





# In[ ]:





# In[ ]:




